﻿Namespace EmployeeMgrMvc
    Public Class EmployeeController
        Inherits System.Web.Mvc.Controller

        Function Index() As ActionResult
            Dim nw As New northwndEntities()
            Return View(nw.Employees)
        End Function

        Function Details(ByVal id As Integer) As ActionResult
            Return View(GetEmployee(id))
        End Function

        Function Create() As ActionResult
            Return View()
        End Function

        <HttpPost()> _
        Function Create(ByVal emp As Employee) As ActionResult
            Try
                Dim nw As New northwndEntities()
                nw.AddToEmployees(emp)
                nw.SaveChanges()
                Return RedirectToAction("Index")
            Catch
                Return View()
            End Try
        End Function
        
        Function Edit(ByVal id As Integer) As ActionResult
            Return View(GetEmployee(id))
        End Function

        <HttpPost()> _
        Function Edit(ByVal emp As Employee) As ActionResult
            Try
                Dim nw As New northwndEntities()
                Dim origEmp As Employee = GetEmployee(emp.EmployeeID)
                nw.Employees.Attach(emp)
                nw.ApplyOriginalValues("Employees", origEmp)
                nw.SaveChanges()
                Return RedirectToAction("Index")
            Catch
                Return View()
            End Try
        End Function

        <NonAction()> _
        Function GetEmployee(ByVal id As Integer) As Employee

            Dim nw As New northwndEntities()
            Dim empQuery = From e In nw.Employees
                   Where e.EmployeeID = id
                   Select e

            Dim emp As Employee = empQuery.FirstOrDefault()

            Return emp

        End Function

    End Class
End Namespace